package com.winhc.bigdata.udf.etl;

import com.aliyun.odps.udf.UDF;
import com.aliyun.odps.utils.StringUtils;
import com.winhc.bigdata.bean.Category;

import java.util.Arrays;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author: XuJiakai
 * 2021/8/23 17:22
 * <p>
 * 限高提取申请人
 */
public class CompanyZxrRestrictProposer extends UDF {

    private final static Pattern pattern = Pattern.compile("立案执行申请人(?<name>.*?)申请执行你");

    public List<String> evaluate(String content) {
        if (StringUtils.isEmpty(content)) {
            return null;
        }
        Matcher matcher = pattern.matcher(content);
        if (matcher.matches()) {
            String name = matcher.group("name");
            return Arrays.asList(name.split("、"));
        }
        return null;
    }
}
